class_name HealthRegeneration
extends Node


@export var health: Health
@export var regeneration_per_unit: int = 1

var timer: Timer


func _ready() -> void:
	timer = Timer.new()
	timer.wait_time = 1 # 1 second
	timer.one_shot = false # can repeat afteer finished
	add_child(timer)
	
	health.health_changed.connect(_start_regeneration)
	health.max_health_changed.connect(_start_regeneration)
	timer.timeout.connect(_regen_health)


func _start_regeneration(_diff: int) -> void:
	if health.health < health.max_health:
		timer.start()
	else:
		timer.stop()


func _regen_health() -> void:
	health.health += regeneration_per_unit
